/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>

static size_t debug_handle;
/* This must be defined before including debug.h */
#define MF_SOURCE_NAME  debug_handle

#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "dns.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006-2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>

static size_t max_ptr = 64;
static size_t max_a = 64;
static size_t max_mx = MAXMXCOUNT;
static struct mu_cfg_param dns_cfg_param[] = {
	{ "max-dns-reply-a", mu_cfg_size, &max_a, 0, NULL,
	  N_("Maximum number of A records in a DNS reply.") },
	{ "max-dns-reply-ptr", mu_cfg_size, &max_a, 0, NULL,
	  N_("Maximum number of PTR records in a DNS reply.") },
	{ "max-dns-reply-mx", mu_cfg_size, &max_mx, 0, NULL,
	  N_("Maximum number of MX records in a DNS reply.") },
	{ NULL }
};


void
#line 36
bi_primitive_hostname(eval_environ_t env)
#line 36

#line 36 "dns.bi"
{
#line 36
	
#line 36

#line 36

#line 36
char * string;
#line 36
        
#line 36
get_string_arg(env, 0, &string);
#line 36
        
#line 36

#line 36
        adjust_stack(env, 1);
#line 36

#line 36
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 36
		prog_trace(env, "primitive_hostname %s",string);;
#line 36

{
	char *hbuf;
	mf_status stat;

	stat = resolve_ipstr(string, &hbuf);
		if (!(stat == mf_success))
#line 42
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_hostname", _("cannot resolve IP %s"),string)
#line 45
;
	
	pushs(env, hbuf);
	free(hbuf);
}
}

void
#line 52
bi_primitive_resolve(eval_environ_t env)
#line 52

#line 52 "dns.bi"
{
#line 52
	
#line 52

#line 52
long __bi_argcnt;
#line 52
char * string;
#line 52
        char * domain;
#line 52
        
#line 52
get_string_arg(env, 1, &string);
#line 52
        get_string_arg(env, 2, &domain);
#line 52
        
#line 52
get_numeric_arg(env, 0, &__bi_argcnt);
#line 52
        adjust_stack(env, __bi_argcnt + 1);
#line 52

#line 52
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 52
		prog_trace(env, "primitive_resolve %s %s",string, ((__bi_argcnt > 1) ? domain : ""));;
#line 52

{
	char *ipstr;
	mf_status stat;
	
	if (((__bi_argcnt > 1) ? domain : "")[0]) {
		stat = resolve_ipstr_domain(string, domain, &ipstr);
			if (!(stat == mf_success))
#line 59
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s.%s"),string,domain)
#line 61
;
	} else {
		stat = resolve_hostname(string, &ipstr);
			if (!(stat == mf_success))
#line 64
			env_throw_bi(env, mf_status_to_exception(stat), "primitive_resolve", _("cannot resolve %s"),string)
#line 66
;
	}
	pushs(env, ipstr);
	free(ipstr);
}
}

static int
ipaddr_cmp(const void *a, const void *b)
{
	GACOPYZ_UINT32_T ipa = ntohl(*(GACOPYZ_UINT32_T*)a);
	GACOPYZ_UINT32_T ipb = ntohl(*(GACOPYZ_UINT32_T*)b);
	if (ipa < ipb)
		return -1;
	if (ipa > ipb)
		return 1;
	return 0;
}

void
#line 85
bi_dns_getaddr(eval_environ_t env)
#line 85

#line 85 "dns.bi"
{
#line 85
	
#line 85

#line 85

#line 85
char * string;
#line 85
        
#line 85
get_string_arg(env, 0, &string);
#line 85
        
#line 85

#line 85
        adjust_stack(env, 1);
#line 85

#line 85
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 85
		prog_trace(env, "dns_getaddr %s",string);;
#line 85

{
	GACOPYZ_UINT32_T *ipbuf;
	size_t i, ipcount;
	unsigned long ttl;
	dns_status dnstat;

	ipbuf = xcalloc(max_a, sizeof(ipbuf[0]));
	dnstat = a_lookup(string, ipbuf, max_a, &ipcount,
			  &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		heap_obstack_begin(env);
		qsort(ipbuf, ipcount, sizeof ipbuf[0], ipaddr_cmp);
		for (i = 0; i < ipcount; i++) {
			struct in_addr addr;
			char *q;
			
			addr.s_addr = ipbuf[i];
			q = inet_ntoa(addr);
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
 			
#line 107
do {
#line 107
  char *__s = q;
#line 107
  heap_obstack_grow(env, __s, strlen(__s));
#line 107
} while (0);
		}
		free(ipbuf);
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		
#line 111
do {
#line 111
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 111
  return;
#line 111
} while (0);
	}
	case dns_not_found:
		free(ipbuf);
		do {pushs(env, "");
#line 115
return;
#line 115
} while (0);
	default:
		free(ipbuf);
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getaddr", _("failed to get A record for %s"),string);
#line 120
	}
}
}

static int
hostname_cmp(const void *a, const void *b)
{
	return strcmp(*(const char**) a, *(const char**) b);
}

void
#line 130
bi_dns_getname(eval_environ_t env)
#line 130

#line 130 "dns.bi"
{
#line 130
	
#line 130

#line 130

#line 130
char * ipstr;
#line 130
        
#line 130
get_string_arg(env, 0, &ipstr);
#line 130
        
#line 130

#line 130
        adjust_stack(env, 1);
#line 130

#line 130
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 130
		prog_trace(env, "dns_getname %s",ipstr);;
#line 130

{
	dns_status dnstat;
	struct in_addr addr;
	unsigned long ttl;
	char **names;

		if (!(inet_aton(ipstr, &addr)))
#line 137
			env_throw_bi(env, mfe_invip, "dns_getname", _("invalid IP: %s"),ipstr)
#line 139
;

	names = xcalloc(max_ptr, sizeof(names[0]));
	dnstat = ptr_lookup(addr, names, max_ptr, &ttl, NULL, 0);
	switch (dnstat) {
	case dns_success: {
		size_t i;
		size_t ncount;

		for (ncount = 0; ncount < max_ptr && names[ncount];
		     ncount++);
		
		qsort(names, ncount, sizeof names[0], hostname_cmp);

		heap_obstack_begin(env);
		for (i = 0; i < ncount; i++) {
			if (i > 0)
				do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 157
do {
#line 157
  char *__s = names[i];
#line 157
  heap_obstack_grow(env, __s, strlen(__s));
#line 157
} while (0);
		}
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);

		for (; i < ncount; i++) 
			free(names[i]);
		free(names);
		
#line 164
do {
#line 164
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 164
  return;
#line 164
} while (0);
	}
	case dns_not_found:
		free(names);
		do {pushs(env, "");
#line 168
return;
#line 168
} while (0);
	default:
		free(names);
			env_throw_bi(env, dns_to_mf_status(dnstat), "dns_getname", _("failed to get PTR record for %s"),ipstr);
#line 173
	}
}
}

void
#line 177
bi_primitive_hasmx(eval_environ_t env)
#line 177

#line 177 "dns.bi"
{
#line 177
	
#line 177

#line 177

#line 177
char * string;
#line 177
        
#line 177
get_string_arg(env, 0, &string);
#line 177
        
#line 177

#line 177
        adjust_stack(env, 1);
#line 177

#line 177
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 177
		prog_trace(env, "primitive_hasmx %s",string);;
#line 177

{
	struct mxbuf mxbuf;
	mf_status mxstat;

	mxbuf.mx_flags = 0;
	mxstat = getmx(string, &mxbuf);
	
		if (!(mxstat == mf_success || mxstat == mf_not_found))
#line 185
			env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_hasmx", _("cannot get MX records for %s"),string)
#line 188
;
	mxbuf_free(&mxbuf);
	if (mxstat == mf_success) {
		
#line 191
do {
#line 191
  push(env, (STKVAL) (1));
#line 191
  return;
#line 191
} while (0);
	}
	
#line 193
do {
#line 193
  push(env, (STKVAL) (0));
#line 193
  return;
#line 193
} while (0);
}
}

void
#line 197
bi_getmx(eval_environ_t env)
#line 197

#line 197 "dns.bi"
{
#line 197
	
#line 197

#line 197
long __bi_argcnt;
#line 197
char * domain;
#line 197
        long  no_resolve;
#line 197
        
#line 197
get_string_arg(env, 1, &domain);
#line 197
        get_numeric_arg(env, 2, &no_resolve);
#line 197
        
#line 197
get_numeric_arg(env, 0, &__bi_argcnt);
#line 197
        adjust_stack(env, __bi_argcnt + 1);
#line 197

#line 197
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 197
		prog_trace(env, "getmx %s %lu",domain, ((__bi_argcnt > 1) ? no_resolve : 0));;
#line 197

{
	mf_status mxstat;

	if (((__bi_argcnt > 1) ? no_resolve : 0)) {
		GACOPYZ_UINT32_T *ipbuf;
		size_t ipcount;

		ipbuf = xcalloc(max_mx, sizeof(ipbuf[0]));
		mxstat = getmxip(domain, ipbuf, max_mx, &ipcount);
		if (!mf_resolved(mxstat)) {
			free(ipbuf);
				env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("cannot get MX records for %s"),domain);
#line 211
		}
		if (mxstat == mf_not_found) {
			free(ipbuf);
			do {pushs(env, "");
#line 214
return;
#line 214
} while (0);
		} else {
			int i;
			
			heap_obstack_begin(env);
			for (i = 0; i < ipcount; i++) {
				struct in_addr s;
				s.s_addr = htonl(ipbuf[i]);
				
				if (i > 0)
					do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
				
#line 225
do {
#line 225
  char *__s = inet_ntoa(s);
#line 225
  heap_obstack_grow(env, __s, strlen(__s));
#line 225
} while (0);
			}
			free(ipbuf);
			do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
			
#line 229
do {
#line 229
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 229
  return;
#line 229
} while (0);
		}
	} else {
		struct mxbuf mxbuf;

		mxbuf.mx_max = max_mx;
		mxbuf.mx_flags = MXF_MAX;
		mxstat = getmx(domain, &mxbuf);
		if (!mf_resolved(mxstat)) {
			mxbuf_free(&mxbuf);
				env_throw_bi(env, mf_status_to_exception(mxstat), "getmx", _("cannot get MX records for %s"),domain);
#line 241
		}
		if (mxstat == mf_not_found) {
			mxbuf_free(&mxbuf);
			do {pushs(env, "");
#line 244
return;
#line 244
} while (0);
		} else {
			int i;
		
			heap_obstack_begin(env);
			for (i = 0; i < mxbuf.mx_cnt; i++) {
				if (i > 0)
					do { char __c = ' '; heap_obstack_grow(env, &__c, 1); } while(0);
				
#line 252
do {
#line 252
  char *__s = mxbuf.mx_buf[i];
#line 252
  heap_obstack_grow(env, __s, strlen(__s));
#line 252
} while (0);
			}
			do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
			mxbuf_free(&mxbuf);
			
#line 256
do {
#line 256
  push(env, (STKVAL) (heap_obstack_finish(env)));
#line 256
  return;
#line 256
} while (0);
		}
	}
}
}

static int
resolve_host(const char *string, unsigned long *ip)
{
	int rc;
	struct in_addr addr;
	char *ipstr;

	if (inet_aton(string, &addr)) {
		*ip = addr.s_addr;
		return 0;
	}
	
	if (resolve_hostname(string, &ipstr) != mf_success)
		return 1;

	rc = inet_aton(ipstr, &addr);
	free(ipstr);
	if (rc == 0) {
		mu_error(_("INTERNAL ERROR at %s:%d: resolve_hostname returned "
			   "invalid IP address: %s"),
			 __FILE__, __LINE__, ipstr);
		return 1;
	}
	*ip = addr.s_addr;
	return 0;
}

void
#line 289
bi_primitive_ismx(eval_environ_t env)
#line 289

#line 289 "dns.bi"
{
#line 289
	
#line 289

#line 289

#line 289
char * domain;
#line 289
        char * ipstr;
#line 289
        
#line 289
get_string_arg(env, 0, &domain);
#line 289
        get_string_arg(env, 1, &ipstr);
#line 289
        
#line 289

#line 289
        adjust_stack(env, 2);
#line 289

#line 289
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 289
		prog_trace(env, "primitive_ismx %s %s",domain, ipstr);;
#line 289

{
	GACOPYZ_UINT32_T *ipbuf;
	size_t ipcount;
	mf_status mxstat;
	unsigned long ip;
	int rc = 0;
	int i;
	
		if (!(resolve_host(ipstr, &ip) == 0))
#line 298
			env_throw_bi(env, mfe_noresolve, "primitive_ismx", _("cannot resolve host name %s"),ipstr)
;
	ip = ntohl(ip);

	ipbuf = xcalloc(max_mx, sizeof(ipbuf[0]));
	mxstat = getmxip(domain, ipbuf, max_mx, &ipcount);

	if (mxstat != mf_success) {
		free(ipbuf);
			env_throw_bi(env, mf_status_to_exception(mxstat), "primitive_ismx", _("cannot get MXs for %s"),domain);
#line 309
	}

	for (i = 0; i < ipcount; i++) {
		if (ipbuf[i] == ip) {
			rc = 1;
			break;
		}
	}
		
	free(ipbuf);
	
#line 319
do {
#line 319
  push(env, (STKVAL) (rc));
#line 319
  return;
#line 319
} while (0);
}
}

void
#line 323
bi_relayed(eval_environ_t env)
#line 323

#line 323 "dns.bi"
{
#line 323
	
#line 323

#line 323

#line 323
char * s;
#line 323
        
#line 323
get_string_arg(env, 0, &s);
#line 323
        
#line 323

#line 323
        adjust_stack(env, 1);
#line 323

#line 323
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 323
		prog_trace(env, "relayed %s",s);;
#line 323

{
	
#line 325
do {
#line 325
  push(env, (STKVAL) (relayed_domain_p(s)));
#line 325
  return;
#line 325
} while (0);
}
}

void
#line 329
bi_listens(eval_environ_t env)
#line 329

#line 329 "dns.bi"
{
#line 329
	
#line 329

#line 329
long __bi_argcnt;
#line 329
char * s;
#line 329
        long  port;
#line 329
        
#line 329
get_string_arg(env, 1, &s);
#line 329
        get_numeric_arg(env, 2, &port);
#line 329
        
#line 329
get_numeric_arg(env, 0, &__bi_argcnt);
#line 329
        adjust_stack(env, __bi_argcnt + 1);
#line 329

#line 329
	if (builtin_module_trace(BUILTIN_IDX_dns))
#line 329
		prog_trace(env, "listens %s %lu",s, ((__bi_argcnt > 1) ? port : 0));;
#line 329

{
	
#line 331
do {
#line 331
  push(env, (STKVAL) (listens_on (s,
#line 331
			      ((__bi_argcnt > 1) ? port : 25),
#line 331
			      smtp_timeout_soft[smtp_timeout_connect])
#line 331
		  == mf_success));
#line 331
  return;
#line 331
} while (0);
#line 335
}
}


#line 338
void
#line 338
dns_init_builtin()
#line 338
{
#line 338
        debug_handle = debug_register("bi_dns");
#line 338
	#line 36 "dns.bi"
va_builtin_install_ex("primitive_hostname", bi_primitive_hostname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 52 "dns.bi"
va_builtin_install_ex("primitive_resolve", bi_primitive_resolve, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_string);
#line 85 "dns.bi"
va_builtin_install_ex("dns_getaddr", bi_dns_getaddr, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 130 "dns.bi"
va_builtin_install_ex("dns_getname", bi_dns_getname, 0, dtype_string, 1, 0, 0|0, dtype_string);
#line 177 "dns.bi"
va_builtin_install_ex("primitive_hasmx", bi_primitive_hasmx, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 197 "dns.bi"
va_builtin_install_ex("getmx", bi_getmx, 0, dtype_string, 2, 1, 0|0, dtype_string, dtype_number);
#line 289 "dns.bi"
va_builtin_install_ex("primitive_ismx", bi_primitive_ismx, 0, dtype_number, 2, 0, 0|0, dtype_string, dtype_string);
#line 323 "dns.bi"
va_builtin_install_ex("relayed", bi_relayed, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 329 "dns.bi"
va_builtin_install_ex("listens", bi_listens, 0, dtype_number, 2, 1, 0|0, dtype_string, dtype_number);

#line 338 "dns.bi"
	
#line 338
	 mf_add_runtime_params(dns_cfg_param);
#line 338
	 
#line 338
}
#line 340

#line 627 "../../mfd/builtin/snarf.m4"

#line 627

